'use strict';

var Log = require('./node');

var _require = require('url'),
    urlParse = _require.parse;

var _require2 = require('querystring'),
    qsParse = _require2.parse;

// https://css-tricks.com/snippets/html/base64-encode-of-1x1px-transparent-gif/


var gif = new Buffer('R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7', 'base64');

// custom logger to use formatter and stream
function CustomLog() {
  Log.call(this, 'middleware');
}
Object.setPrototypeOf(CustomLog.prototype, Log.prototype);
CustomLog.prototype.log = function (obj) {
  var str = this.formatter.format(obj);
  this.render(str);
};

module.exports = middleware;

/**
* connect middleware which logs browser based logs on server side
* sends a transparent gif as response
* @return {function} connect middleware
*/
function middleware() {
  var log = new CustomLog();

  return function (req, res) {
    var query = req.query;
    if (!req.query) {
      query = qsParse(urlParse(req.url).query);
    }
    res.setHeader('Cache-Control', 'no-store, no-cache');
    res.write(gif);
    res.end();

    var str = query.log;
    if (str) {
      if (req.ip) {
        try {
          var obj = JSON.parse(str);
          obj.ip = req.ip;
          log.log(obj);
          return;
        } catch (e) {}
      }
    }
    log.log(str);
  };
}